#ifndef __REFRESH_UI_H__
#define __REFRESH_UI_H__

#include "wbpublic_public_interface.h"
#include <sigc++/sigc++.h>

namespace bec
{

//! Class to save on typing and copy/paste of code. If you need to 
//! have a refresh feedback from BE to FE just derive from RefreshUI.
class WBPUBLICBACKEND_PUBLIC_FUNC RefreshUI
{
  public:
    virtual ~RefreshUI() {}
    
    typedef sigc::slot<void>              RefreshSlot;
    typedef sigc::slot<void,const int>    PartialRefreshSlot;

    void set_refresh_ui_slot(const RefreshSlot &slot);
    //! A way to make a refresh of part of the editor
    //! This actually is preffed upon whole-thing refresh
    void set_partial_refresh_ui_slot(const PartialRefreshSlot &slot);

    void do_partial_ui_refresh(const int what);
    void do_ui_refresh();

    void block_auto_refresh()    { _refresh_ui.block(); _partial_refresh_ui.block(); }
    void unblock_auto_refresh()  { _refresh_ui.unblock(); _partial_refresh_ui.unblock(); }

  private:
    sigc::slot<void>      _refresh_ui;
    PartialRefreshSlot    _partial_refresh_ui;
};

}

#endif
