#include "stdafx.h"

#include "grt/grt_dispatcher.h"
//#include "db_mysql_statement_parser_be.h"
#include "editor_routine.h"

#define DEFAULT_PROCEDURE_TEMPLATE \
"CREATE PROCEDURE `%s`.`%s` ()\n"\
"BEGIN\n"\
"\n"\
"END//\n"


namespace bec {

RoutineEditorBE::RoutineEditorBE(GRTManager *grtm, const db_RoutineRef &routine, const db_mgmt_RdbmsRef &rdbms)
  : DBObjectEditorBE(grtm, routine, rdbms), _routine(routine), _has_syntax_error(false)
{
}

std::string RoutineEditorBE::get_sql()
{
  return _routine->sqlDefinition();
}

std::string RoutineEditorBE::get_object_type()
{
  return "routine";
}


std::string RoutineEditorBE::get_sql_template(const std::string &template_name, int &cursor_pos)
{
  char *sql= NULL;
  char *pos;
  if (template_name.empty() || template_name == "default")
  {
    sql= g_strdup_printf(DEFAULT_PROCEDURE_TEMPLATE, 
                         get_schema_name().c_str(), get_name().c_str());
  }
  
  pos= strstr(sql, "BEGIN");
  if (pos)
    cursor_pos= (pos - sql) + 6;
  
  std::string tmp(sql);
  g_free(sql);
  return tmp;
}


void RoutineEditorBE::set_sql(const std::string &sql)
{
  if (get_sql() != sql)
  {
    set_sql_parser_task_cb(sigc::mem_fun(this, &RoutineEditorBE::parse_sql));
    DBObjectEditorBE::set_sql(sql, _routine);
  }
}


grt::ValueRef RoutineEditorBE::parse_sql(grt::GRT*, grt::StringRef sql)
{
  int err_count= _sql_parser->parse_routine(_routine, sql.c_str());
  _has_syntax_error= 0 < err_count;
  return grt::IntegerRef(err_count);
}

} // namespace bec
