#ifndef _INVALID_SQL_PARSER_H_
#define _INVALID_SQL_PARSER_H_


#include "wbpublic_public_interface.h"
#include "sql_parser_base.h"


/** Defines interface to transform single DDL statement into GRT object with special processing of syntax errors in mind.
 * In case of syntax error instance of derived class creates placeholder GRT object containing provided SQL and marks it as invalid.
 * 
 * @ingroup sqlparser
 */
class WBPUBLICBACKEND_PUBLIC_FUNC Invalid_sql_parser : virtual public Sql_parser_base
{
public:
  virtual int parse_inserts(db_TableRef table, const std::string &sql)= 0;
  virtual int parse_triggers(db_TableRef table, const std::string &sql)= 0;
  virtual int parse_routines(db_RoutineGroupRef routine_group, const std::string &sql)= 0;
  virtual int parse_routine(db_RoutineRef routine, const std::string &sql)= 0;
  virtual int parse_view(db_ViewRef view, const std::string &sql)= 0;
};


#endif // _INVALID_SQL_PARSER_H_
