#ifndef _MODULE_UTILS_
#define _MODULE_UTILS_


#include "wbpublic_public_interface.h"
#include <grtpp_undo_manager.h>

template<typename T1>
void overwrite_default_option(bool &value, const char *name, grt::DictRef &options)
{
  if (options.is_valid() && options.has_key(name))
    value= T1::cast_from(options.get(name)) != 0;
}

template<typename T>
void overwrite_default_option(T &value, const char *name, grt::DictRef &options, bool init_with_empty_value)
{
  if (options.is_valid() && options.has_key(name))
  {
    value= T::cast_from(options.get(name));
    if (init_with_empty_value && !value.is_valid())
      value= T(options.get_grt());
  }
}


WBPUBLICBACKEND_PUBLIC_FUNC void begin_undo_group(grt::UndoManager *undo_man);
WBPUBLICBACKEND_PUBLIC_FUNC void end_undo_group(grt::UndoManager *undo_man, std::string desc);

WBPUBLICBACKEND_PUBLIC_FUNC void do_transactable_member_set(grt::UndoManager *undo_man, grt::ObjectRef object, const char *member, grt::ValueRef value);
WBPUBLICBACKEND_PUBLIC_FUNC void do_transactable_list_insert(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val);
WBPUBLICBACKEND_PUBLIC_FUNC void do_transactable_list_remove(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val);
WBPUBLICBACKEND_PUBLIC_FUNC void do_transactable_list_remove_by(grt::UndoManager *undo_man, grt::BaseListRef list, size_t index);


#endif // _MODULE_UTILS_
