#ifndef _SQL_INSERTS_LOADER_H_
#define _SQL_INSERTS_LOADER_H_


#include "wbpublic_public_interface.h"
#include <sigc++/sigc++.h>
#include <vector>
#include <string>


/**
 * Defines interface to facilitate loading data from inserts SQL script.
 * 
 * @ingroup sqlparser
 */
class WBPUBLICBACKEND_PUBLIC_FUNC Sql_inserts_loader
{
public:
  Sql_inserts_loader() {}
  virtual ~Sql_inserts_loader() {}

  virtual void load(const std::string &sql, const std::string &schema_name)= 0;

  typedef std::vector<std::string> Strings;
  typedef sigc::slot<void, const std::string&, const std::string&, const std::string&, const Strings&, const Strings&> Process_insert; // sql, schema_name, table_name, fields_names, fields_values
  void process_insert_cb(Process_insert cb) { _process_insert= cb; }

protected:
  Process_insert _process_insert;
};


#endif // _SQL_INSERTS_LOADER_H_
