#ifndef _SQL_SYNTAX_CHECK_H_
#define _SQL_SYNTAX_CHECK_H_


#include "wbpublic_public_interface.h"
#include "sql_parser_base.h"


/**
 * Defines interface to check syntax of provided SQL statement/script.
 * 
 * @ingroup sqlparser
 */
class WBPUBLICBACKEND_PUBLIC_FUNC Sql_syntax_check : virtual public Sql_parser_base
{
public:
  virtual int check_sql_syntax(const std::string &sql)= 0;
  virtual int check_trigger_syntax(const std::string &sql)= 0;
  virtual int check_view_syntax(const std::string &sql)= 0;
  virtual int check_routine_syntax(const std::string &sql)= 0;
};


#endif // _SQL_SYNTAX_CHECK_H_
