#include "stdafx.h"

#include "gui_plugin_base.h"
#include "grt/plugin_manager.h"

GUIPluginBase::GUIPluginBase(grt::Module *module)
  : _module(module), _grt(module->get_grt())
{
}

GUIPluginBase::~GUIPluginBase()
{
  grtm()->get_plugin_manager()->forget_gui_plugin_handle(reinterpret_cast<NativeHandle>(this));
}

void GUIPluginBase::set_global_option(const std::string &key, const std::string &value)
{
  _module->set_global_option(key, value);
}

void GUIPluginBase::set_global_option(const std::string &key, int value)
{
  _module->set_global_option(key, value);
}

int GUIPluginBase::global_int_option(const std::string &key, int default_value)
{
  return _module->global_int_option(key, default_value);
}

bool GUIPluginBase::global_bool_option(const std::string &key, bool default_value)
{
  return _module->global_int_option(key, default_value ? 1 : 0) != 0;
}

std::string GUIPluginBase::global_string_option(const std::string &key, const std::string &default_value)
{
  return _module->global_string_option(key, default_value);
}
