#ifndef _GUI_PLUGIN_BASE_H_
#define _GUI_PLUGIN_BASE_H_

#include "grt/grt_manager.h"

//! Base class with some utility stuff for gui plugins and others 
class WBPUBLICBACKEND_PUBLIC_FUNC GUIPluginBase
{
  grt::Module *_module;
  grt::GRT *_grt;

protected:
  bec::GRTManager *grtm() { return bec::GRTManager::get_instance_for(_grt); }
 
  sigc::signal<void> _signal_closed; 

  void set_global_option(const std::string &key, const std::string &value);
  void set_global_option(const std::string &key, int value);
  int global_int_option(const std::string &key, int default_value= 0);
  bool global_bool_option(const std::string &key, bool default_value= false);
  std::string global_string_option(const std::string &key, const std::string &default_value= "");

public:
  GUIPluginBase(grt::Module *module);
  virtual ~GUIPluginBase();
};


typedef GUIPluginBase* (*GUIPluginCreateFunction)(grt::Module *module, bec::GRTManager *grtm, grt::BaseListRef &args);

#endif /* _WB_PLUGIN_BASE_H_ */
