#ifndef _WIZARD_VIEW_TEXT_PAGE_H_
#define _WIZARD_VIEW_TEXT_PAGE_H_



namespace grtui {

class WBPUBLICBACKEND_PUBLIC_FUNC ViewTextPage : public WizardPage
{
public:
  enum Buttons
  {
    SaveButton = (1<<0),
    CopyButton = (1<<1)
  };
  
  ViewTextPage(WizardForm *form, const char *name= "preview", Buttons buttons= (Buttons)0, const std::string &filetype="");

  void set_text(const std::string &text);
  std::string get_text();
  
  void set_editable(bool flag= true);

  void save_text_to(const std::string &path);
  
protected:
  mforms::TextBox _text;
  
  mforms::Box _button_box;
  mforms::Button _save_button;
  mforms::Button _copy_button;
  
  std::string _filetype;
  
  void save_clicked();
  void copy_clicked();
};

};

#endif /* _WIZARD_VIEW_TEXT_PAGE_H_ */

