
/*!
 Copyright 2009 Sun Microsystems, Inc.
*/



#import "WBTabItem.h"



@class ResponderLayer;
@class WBRightClickThroughView;


@interface WBTabView : NSTabView <WBTabItemDelegateProtocol>
{
	NSTabView* mTabView;
	ResponderLayer* mTabRowLayer;
	WBRightClickThroughView* mTabRowView;
	NSMutableArray* mTabItems;
	WBTabItem* mSelectedTab;
	ResponderLayer* mMouseDownLayer;
	BOOL mEnabled;
	NSString* mLabel;
	WBTabSize mTabSize;
	WBTabDirection mTabDirection;
	WBTabPlacement mTabPlacement;

	CGColorRef mColorActiveSelected;
	CGColorRef mColorActiveNotSelected;
	CGColorRef mColorNotActiveSelected;
	CGColorRef mColorNotActiveNotSelected;

	BOOL mDoneCustomizing;
//	BOOL mAllowsTabReordering;
}

- (CGFloat) tabAreaHeight;
//- (void) setAllowsTabReordering: (BOOL) yn;
- (NSSize) contentSize;
- (CALayer*) shadowLayer;
- (void) doCustomize;
- (void) updateLabelForTabViewItem: (id) identifier;
@end



@protocol WBTabViewDelegateProtocol

- (void) tabView: (NSTabView*) tabView 
willCloseTabViewItem: (NSTabViewItem*) tabViewItem;

@end



