//
//  WBModelDiagramPanel.h
//  MySQLWorkbench
//
//  Created by Alfredo Kojima on 6/Oct/08.
//  Copyright 2008 Sun Microsystems Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "WBBasePanel.h"
#import "MCanvasViewer.h"

@class MCanvasScrollView;

namespace bec
{
  class UIForm;
};
namespace wb
{
  class ModelDiagramForm;
};

@interface WBModelDiagramPanel : WBBasePanel 
{
  NSString *_identifier;
  MCanvasViewer *_viewer;
  MCanvasScrollView *_scrollView;
  wb::ModelDiagramForm *_formBE;
}

- (id)initWithId:(NSString*)oid
          formBE:(wb::ModelDiagramForm*)be;
- (NSView*)topView;

- (NSString*)identifier;
- (bec::UIForm*)formBE;

- (void)updateCursor;

- (MCanvasViewer*)canvasViewer;
- (mdc::CanvasView*)canvas;

@end
