//
//  cf_view.h
//  MySQLWorkbench
//
//  Created by Alfredo Kojima on 21/Jan/09.
//  Copyright 2009 Sun Microsystems Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#include "MFBase.h"


/** MForms control implementations must subclass their own NS counterpart and implement the methods
 * below.  
 */
@interface NSView(MForms)

- (id)innerView;

- (void)subviewMinimumSizeChanged;
- (NSSize)minimumSize;
- (NSSize)minimumSizeForWidth:(float)width;
- (NSSize)preferredSize;
- (NSSize)preferredSizeForWidth:(float)width;

- (BOOL)widthIsFixed;
- (BOOL)heightIsFixed;

// Tag is used for internal purposes (special flags), do not use it for anything else
- (void)setTag:(NSUInteger)tag;

@end



