#ifndef _MFORMS_BUTTON_H_
#define _MFORMS_BUTTON_H_

#include <mforms/base.h>
#include <mforms/control.h>

#include <sigc++/sigc++.h>

namespace mforms {
  class Button;

  struct ButtonImplPtrs
  {
    bool (__stdcall *create)(Button *self);
    void (__stdcall *set_text)(Button *self, const std::string &text);
    void (__stdcall *enable_internal_padding)(Button *self, bool);
  };

  class MFORMS_EXPORT Button : public Control
  {
  public:
    Button();

    void enable_internal_padding(bool flag);
    void set_text(const std::string &text);

    sigc::signal<void> &signal_clicked() { return _clicked; }

  public:
    void callback();

  protected:
    sigc::signal<void> _clicked;
    ButtonImplPtrs *_button_impl;
  };
};

#endif
