
// (c) 2009 Sun Microsystems Inc.

#include "stdafx.h"
#include "wf_button.h"

using namespace MySQL;
using namespace MySQL::Forms;

//-------------------------------------------------------------------------------------------------

ButtonImpl::ButtonImpl(::mforms::Button *self)
  : ViewImpl(self)
{
}

//-------------------------------------------------------------------------------------------------

bool ButtonImpl::create(::mforms::Button *self)
{
  ButtonImpl ^button= gcnew ButtonImpl(self);

  if (button != nullptr)
  {
    Windows::Forms::Button ^b= ViewImpl::create<Button>(self, button);
    b->UseMnemonic= true;
    b->Click += gcnew System::EventHandler(&ButtonImpl::button_click);
    return true;
  }
  return false;
}

//-------------------------------------------------------------------------------------------------

void ButtonImpl::set_text(::mforms::Button *self, const std::string &text)
{
  ButtonImpl^ button= (ButtonImpl^)ObjectImpl::FromUnmanaged(self);

  if (button != nullptr)
  {
    std::string tmp;
  
    if (text.find('_') != std::string::npos)
    {
      tmp.append(text.substr(0, text.find('_')));
      tmp.append("&");
      tmp.append(text.substr(text.find('_')+1));
    }
    else
      tmp= text;

    Control^ control= button->get_control<Control>();
    control->Text= CppStringToNative(tmp);

    // Resize the button to fit its content.
    Size size= control->PreferredSize;
    if (size.Width < control->Width)
      size.Width= control->Width;
    if (size.Height < control->Height)
      size.Height= control->Height;
    control->Size= size;
  }
}

//-------------------------------------------------------------------------------------------------

void ButtonImpl::button_click(System::Object ^sender, System::EventArgs ^e)
{
  Windows::Forms::Button^ btn= (Windows::Forms::Button^)sender;

  if (btn->Tag != nullptr)
  {
    ::mforms::Button* button= ViewImpl::get_backend_control<::mforms::Button>(btn);
    if (button != 0)
      button->callback();
  }
}

//-------------------------------------------------------------------------------------------------

void ButtonImpl::enable_internal_padding(::mforms::Button *self, bool flag)
{
  ButtonImpl^ button= (ButtonImpl^)ObjectImpl::FromUnmanaged(self);

  // The internal padding feature is just some beautfying added to the button
  // gives it a bit more room left and right of the text than what is the default
  // for it.
  Button^ native_button= button->get_control<Button>();
  int extra= native_button->Height / 2;
  native_button->Padding= Padding::Add(native_button->Padding, Padding(extra, 0, extra, 0));
}

//-------------------------------------------------------------------------------------------------

