#ifndef _WF_BUTTON_H_
#define _WF_BUTTON_H_

/**
 * Implements a wrapper class for a .NET button control, which can be used by the mforms library.
 *
 * @ingroup mforms
 */

#include "mforms/button.h"
#include "wf_view.h"

using namespace System;
using namespace Windows::Forms;


namespace MySQL {
  namespace Forms {

    /*
     * Implements a wrapper class around a .NET button control, so it can be used by the mforms library.
     */
    public ref class ButtonImpl : public ViewImpl
    {
    protected:
      ButtonImpl(::mforms::Button *self);

      static bool create(::mforms::Button *self);
      static void set_text(::mforms::Button *self, const std::string &text);
      static void button_click(System::Object ^sender, System::EventArgs ^e);
      static void enable_internal_padding(::mforms::Button *self, bool flag);
    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::Button*, mgr, f->_button_impl, ButtonImpl, create);
        DEF_CALLBACK2(void, ::mforms::Button*, const std::string&, mgr, f->_button_impl, ButtonImpl, set_text);
        DEF_CALLBACK2(void, ::mforms::Button*, bool, mgr, f->_button_impl, ButtonImpl, enable_internal_padding);
      }
    };

  };
};


#endif
