#ifndef _WF_CHECKBOX_H_
#define _WF_CHECKBOX_H_

#include <mforms/mforms.h>

#include "wf_button.h"


using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class CheckBoxImpl : public ButtonImpl
    {
      static bool create(::mforms::CheckBox *self)
      {
        CheckBoxImpl ^cb= gcnew CheckBoxImpl(self);

        if (cb != nullptr)
        {
          CheckBox^ box= ViewImpl::create<CheckBox>(self, cb);
          box->Click += gcnew System::EventHandler(&CheckBoxImpl::click);
          return true;
        }
        return false;
      }

      static void click(System::Object ^sender, System::EventArgs ^e)
      {
        Windows::Forms::CheckBox^ box= (Windows::Forms::CheckBox^)sender;

        if (box->Tag != nullptr)
        {
          ::mforms::Button* button= ViewImpl::get_backend_control<::mforms::Button>(box);
          if (button != 0)
            button->callback();
        }
      }

      static void set_active(::mforms::CheckBox *self, bool flag)
      {
        CheckBoxImpl^ cb= (CheckBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          cb->get_control<CheckBox>()->Checked= flag;
        }
      }

      static bool get_active(::mforms::CheckBox *self)
      {
        CheckBoxImpl^ cb= (CheckBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          return cb->get_control<CheckBox>()->Checked;
        }
        return false;
      }

      CheckBoxImpl(::mforms::CheckBox *cbox)
        : ButtonImpl(cbox)
      {
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::CheckBox*, mgr, f->_checkbox_impl, CheckBoxImpl, create);
        DEF_CALLBACK2(void, ::mforms::CheckBox*, bool, mgr, f->_checkbox_impl, CheckBoxImpl, set_active);
        DEF_CALLBACK1(bool, ::mforms::CheckBox*, mgr, f->_checkbox_impl, CheckBoxImpl, get_active);
      }
    };

  };
};

#endif
