#ifndef _WF_IMAGEBOX_H_
#define _WF_IMAGEBOX_H_

#include <mforms/mforms.h>

#include "wf_view.h"


using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class ImageBoxImpl : public ViewImpl
    {
      static bool create(::mforms::ImageBox *self)
      {
        ImageBoxImpl ^cb= gcnew ImageBoxImpl(self);

        if (cb != nullptr)
        {
          PictureBox ^pb= ViewImpl::create<PictureBox>(self, cb);
          pb->SizeMode = PictureBoxSizeMode::AutoSize;
          return true;
        }
        return false;
      }

      static void set_image(::mforms::ImageBox *self, const std::string &file)
      {
        ImageBoxImpl^ cb= (ImageBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr && !file.empty())
        {
          PictureBox^ box= cb->get_control<PictureBox>();
          String^ name= CppStringToNative(file);
          if (IO::File::Exists(name))
            box->Load(name);
          else
            box->Load(Application::StartupPath + "\\" + name);
        }
      }

      ImageBoxImpl(::mforms::ImageBox *image)
        : ViewImpl(image)
      {
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::ImageBox*, mgr, f->_imagebox_impl, ImageBoxImpl, create);
        DEF_CALLBACK2(void, ::mforms::ImageBox*, const std::string&, mgr, f->_imagebox_impl, ImageBoxImpl, set_image);
      }
    };

  };
};

#endif
