#ifndef _WF_TABVIEW_H_
#define _WF_TABVIEW_H_

#include "wf_view.h"

namespace MySQL
{
  namespace Forms
  {
    public ref class TabViewImpl : public ViewImpl
    {
    protected:
      TabViewImpl(::mforms::TabView *self);

      static bool create(::mforms::TabView *self);
      static void set_active_tab(::mforms::TabView *self, int index);
      static int get_active_tab(::mforms::TabView *self);
      static int add_page(::mforms::TabView *self, ::mforms::View *page, const std::string& caption);

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::TabView*, mgr, f->_tabview_impl, TabViewImpl, create);
        DEF_CALLBACK1(int, ::mforms::TabView*, mgr, f->_tabview_impl, TabViewImpl, get_active_tab);
        DEF_CALLBACK2(void, ::mforms::TabView*, int, mgr, f->_tabview_impl, TabViewImpl, set_active_tab);
        DEF_CALLBACK3(int, ::mforms::TabView*, ::mforms::View*, const std::string&, mgr, f->_tabview_impl, TabViewImpl, add_page);
      }
    };
  };
};

#endif
