#ifndef _WF_Utilities_H_
#define _WF_Utilities_H_

// Copyright (c) Sun Microsystems, Inc.

#include <mforms/mforms.h>
#include "mforms/utilities.h"

#include "wf_mforms.h"

using namespace std;

namespace MySQL {
  namespace Forms {

    public ref class UtilitiesImpl
    {
    protected:
      UtilitiesImpl();

      static int show_message(const string &title, const string &text, const string &ok, 
        const string &cancel, const string &other);
      static int show_error(const string &title, const string &text, const string &ok, 
        const string &cancel, const string &other);
      static int show_warning(const string &title, const string &text, const string &ok, 
        const string &cancel, const string &other);

      static void set_clipboard_text(const string &content);
      static std::string get_clipboard_text();
    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK5(int, const string&, const string&, const string&, const string&, const string&, 
          mgr, f->_utilities_impl, UtilitiesImpl, show_message);
        DEF_CALLBACK5(int, const string&, const string&, const string&, const string&, const string&, 
          mgr, f->_utilities_impl, UtilitiesImpl, show_error);
        DEF_CALLBACK5(int, const string&, const string&, const string&, const string&, const string&, 
          mgr, f->_utilities_impl, UtilitiesImpl, show_warning);
        DEF_CALLBACK1(void, const string&, mgr, f->_utilities_impl, UtilitiesImpl, set_clipboard_text);
        //DEF_CALLBACK(string, mgr, f->_utilities_impl, UtilitiesImpl, get_clipboard_text);
      }
    };

  };
};

#endif // _WF_Utilities_H_
