/*
 *  python_grtobject.h
 *  MySQLWorkbench
 *
 *  Created by Alfredo Kojima on 14/Feb/09.
 *  Copyright 2009 Sun Microsystems Inc. All rights reserved.
 *
 */


#ifndef __PYTHON_GRTOBJECT_H__
#define __PYTHON_GRTOBJECT_H__

#ifdef __APPLE__
#include <Python/Python.h>
#include <Python/object.h>
#else
#include <Python.h>
#include <object.h>
#endif

#include "grtpp.h"

/** Wraps a GRT object as a Python object
 */
struct PyGRTObjectObject
{
  PyObject_HEAD
  
  grt::ObjectRef *object;
};


/** Wraps a GRT method as a Python object
 */
struct PyGRTMethodObject
{
  PyObject_HEAD
  
  grt::ObjectRef *object;
  const grt::MetaClass::Method *method;
};

#endif
